(function(h,c){typeof exports=="object"&&typeof module!="undefined"?c(exports):typeof define=="function"&&define.amd?define(["exports"],c):(h=typeof globalThis!="undefined"?globalThis:h||self,c(h.SDKWebSockets={}))})(this,function(h){"use strict";var c={logger:self.console,WebSocket:self.WebSocket},s={log(...n){this.enabled&&(n.push(Date.now()),c.logger.log("[ActionCable]",...n))}};const l=()=>new Date().getTime(),u=n=>(l()-n)/1e3;class p{constructor(t){this.visibilityDidChange=this.visibilityDidChange.bind(this),this.connection=t,this.reconnectAttempts=0}start(){this.isRunning()||(this.startedAt=l(),delete this.stoppedAt,this.startPolling(),addEventListener("visibilitychange",this.visibilityDidChange),s.log(`ConnectionMonitor started. stale threshold = ${this.constructor.staleThreshold} s`))}stop(){this.isRunning()&&(this.stoppedAt=l(),this.stopPolling(),removeEventListener("visibilitychange",this.visibilityDidChange),s.log("ConnectionMonitor stopped"))}isRunning(){return this.startedAt&&!this.stoppedAt}recordPing(){this.pingedAt=l()}recordConnect(){this.reconnectAttempts=0,this.recordPing(),delete this.disconnectedAt,s.log("ConnectionMonitor recorded connect")}recordDisconnect(){this.disconnectedAt=l(),s.log("ConnectionMonitor recorded disconnect")}startPolling(){this.stopPolling(),this.poll()}stopPolling(){clearTimeout(this.pollTimeout)}poll(){this.pollTimeout=setTimeout(()=>{this.reconnectIfStale(),this.poll()},this.getPollInterval())}getPollInterval(){const{staleThreshold:t,reconnectionBackoffRate:e}=this.constructor,i=Math.pow(1+e,Math.min(this.reconnectAttempts,10)),r=(this.reconnectAttempts===0?1:e)*Math.random();return t*1e3*i*(1+r)}reconnectIfStale(){this.connectionIsStale()&&(s.log(`ConnectionMonitor detected stale connection. reconnectAttempts = ${this.reconnectAttempts}, time stale = ${u(this.refreshedAt)} s, stale threshold = ${this.constructor.staleThreshold} s`),this.reconnectAttempts++,this.disconnectedRecently()?s.log(`ConnectionMonitor skipping reopening recent disconnect. time disconnected = ${u(this.disconnectedAt)} s`):(s.log("ConnectionMonitor reopening"),this.connection.reopen()))}get refreshedAt(){return this.pingedAt?this.pingedAt:this.startedAt}connectionIsStale(){return u(this.refreshedAt)>this.constructor.staleThreshold}disconnectedRecently(){return this.disconnectedAt&&u(this.disconnectedAt)<this.constructor.staleThreshold}visibilityDidChange(){document.visibilityState==="visible"&&setTimeout(()=>{(this.connectionIsStale()||!this.connection.isOpen())&&(s.log(`ConnectionMonitor reopening stale connection on visibilitychange. visibilityState = ${document.visibilityState}`),this.connection.reopen())},200)}}p.staleThreshold=6,p.reconnectionBackoffRate=.15;var C={message_types:{welcome:"welcome",disconnect:"disconnect",ping:"ping",confirmation:"confirm_subscription",rejection:"reject_subscription"},disconnect_reasons:{unauthorized:"unauthorized",invalid_request:"invalid_request",server_restart:"server_restart",remote:"remote"},default_mount_path:"/cable",protocols:["actioncable-v1-json","actioncable-unsupported"]};const{message_types:a,protocols:f}=C,_=f.slice(0,f.length-1),y=[].indexOf;class g{constructor(t){this.open=this.open.bind(this),this.consumer=t,this.subscriptions=this.consumer.subscriptions,this.monitor=new p(this),this.disconnected=!0}send(t){return this.isOpen()?(this.webSocket.send(JSON.stringify(t)),!0):!1}open(){if(this.isActive())return s.log(`Attempted to open WebSocket, but existing socket is ${this.getState()}`),!1;{const t=[...f,...this.consumer.subprotocols||[]];return s.log(`Opening WebSocket, current state is ${this.getState()}, subprotocols: ${t}`),this.webSocket&&this.uninstallEventHandlers(),this.webSocket=new c.WebSocket(this.consumer.url,t),this.installEventHandlers(),this.monitor.start(),!0}}close({allowReconnect:t}={allowReconnect:!0}){if(t||this.monitor.stop(),this.isOpen())return this.webSocket.close()}reopen(){if(s.log(`Reopening WebSocket, current state is ${this.getState()}`),this.isActive())try{return this.close()}catch(t){s.log("Failed to reopen WebSocket",t)}finally{s.log(`Reopening WebSocket in ${this.constructor.reopenDelay}ms`),setTimeout(this.open,this.constructor.reopenDelay)}else return this.open()}getProtocol(){if(this.webSocket)return this.webSocket.protocol}isOpen(){return this.isState("open")}isActive(){return this.isState("open","connecting")}triedToReconnect(){return this.monitor.reconnectAttempts>0}isProtocolSupported(){return y.call(_,this.getProtocol())>=0}isState(...t){return y.call(t,this.getState())>=0}getState(){if(this.webSocket){for(let t in c.WebSocket)if(c.WebSocket[t]===this.webSocket.readyState)return t.toLowerCase()}return null}installEventHandlers(){for(let t in this.events){const e=this.events[t].bind(this);this.webSocket[`on${t}`]=e}}uninstallEventHandlers(){for(let t in this.events)this.webSocket[`on${t}`]=function(){}}}g.reopenDelay=500,g.prototype.events={message(n){if(!this.isProtocolSupported())return;const{identifier:t,message:e,reason:i,reconnect:o,type:r}=JSON.parse(n.data);switch(r){case a.welcome:return this.triedToReconnect()&&(this.reconnectAttempted=!0),this.monitor.recordConnect(),this.subscriptions.reload();case a.disconnect:return s.log(`Disconnecting. Reason: ${i}`),this.close({allowReconnect:o});case a.ping:return this.monitor.recordPing();case a.confirmation:return this.subscriptions.confirmSubscription(t),this.reconnectAttempted?(this.reconnectAttempted=!1,this.subscriptions.notify(t,"connected",{reconnected:!0})):this.subscriptions.notify(t,"connected",{reconnected:!1});case a.rejection:return this.subscriptions.reject(t);default:return this.subscriptions.notify(t,"received",e)}},open(){if(s.log(`WebSocket onopen event, using '${this.getProtocol()}' subprotocol`),this.disconnected=!1,!this.isProtocolSupported())return s.log("Protocol is unsupported. Stopping monitor and disconnecting."),this.close({allowReconnect:!1})},close(n){if(s.log("WebSocket onclose event"),!this.disconnected)return this.disconnected=!0,this.monitor.recordDisconnect(),this.subscriptions.notifyAll("disconnected",{willAttemptReconnect:this.monitor.isRunning()})},error(){s.log("WebSocket onerror event")}};const T=function(n,t){if(t!=null)for(let e in t){const i=t[e];n[e]=i}return n};class O{constructor(t,e={},i){this.consumer=t,this.identifier=JSON.stringify(e),T(this,i)}perform(t,e={}){return e.action=t,this.send(e)}send(t){return this.consumer.send({command:"message",identifier:this.identifier,data:JSON.stringify(t)})}unsubscribe(){return this.consumer.subscriptions.remove(this)}}class P{constructor(t){this.subscriptions=t,this.pendingSubscriptions=[]}guarantee(t){this.pendingSubscriptions.indexOf(t)==-1?(s.log(`SubscriptionGuarantor guaranteeing ${t.identifier}`),this.pendingSubscriptions.push(t)):s.log(`SubscriptionGuarantor already guaranteeing ${t.identifier}`),this.startGuaranteeing()}forget(t){s.log(`SubscriptionGuarantor forgetting ${t.identifier}`),this.pendingSubscriptions=this.pendingSubscriptions.filter(e=>e!==t)}startGuaranteeing(){this.stopGuaranteeing(),this.retrySubscribing()}stopGuaranteeing(){clearTimeout(this.retryTimeout)}retrySubscribing(){this.retryTimeout=setTimeout(()=>{this.subscriptions&&typeof this.subscriptions.subscribe=="function"&&this.pendingSubscriptions.map(t=>{s.log(`SubscriptionGuarantor resubscribing ${t.identifier}`),this.subscriptions.subscribe(t)})},500)}}class R{constructor(t){this.consumer=t,this.guarantor=new P(this),this.subscriptions=[]}create(t,e){const i=t,o=typeof i=="object"?i:{channel:i},r=new O(this.consumer,o,e);return this.add(r)}add(t){return this.subscriptions.push(t),this.consumer.ensureActiveConnection(),this.notify(t,"initialized"),this.subscribe(t),t}remove(t){return this.forget(t),this.findAll(t.identifier).length||this.sendCommand(t,"unsubscribe"),t}reject(t){return this.findAll(t).map(e=>(this.forget(e),this.notify(e,"rejected"),e))}forget(t){return this.guarantor.forget(t),this.subscriptions=this.subscriptions.filter(e=>e!==t),t}findAll(t){return this.subscriptions.filter(e=>e.identifier===t)}reload(){return this.subscriptions.map(t=>this.subscribe(t))}notifyAll(t,...e){return this.subscriptions.map(i=>this.notify(i,t,...e))}notify(t,e,...i){let o;return typeof t=="string"?o=this.findAll(t):o=[t],o.map(r=>typeof r[e]=="function"?r[e](...i):void 0)}subscribe(t){this.sendCommand(t,"subscribe")&&this.guarantor.guarantee(t)}confirmSubscription(t){s.log(`Subscription confirmed ${t}`),this.findAll(t).map(e=>this.guarantor.forget(e))}sendCommand(t,e){const{identifier:i}=t;return this.consumer.send({command:e,identifier:i})}}class D{constructor(t){this._url=t,this.subscriptions=new R(this),this.connection=new g(this),this.subprotocols=[]}get url(){return $(this._url)}send(t){return this.connection.send(t)}connect(){return this.connection.open()}disconnect(){return this.connection.close({allowReconnect:!1})}ensureActiveConnection(){if(!this.connection.isActive())return this.connection.open()}addSubProtocol(t){this.subprotocols=[...this.subprotocols,t]}}function $(n){if(typeof n=="function"&&(n=n()),n&&!/^wss?:/i.test(n)){const t=document.createElement("a");return t.href=n,t.href=t.href,t.protocol=t.protocol.replace("http","ws"),t.href}else return n}class b extends Error{constructor(t){super(t),this.name="MissingConfigError",Object.setPrototypeOf(this,b.prototype)}}class m extends Error{constructor(t){super(t),this.name="MissingTokenError",Object.setPrototypeOf(this,m.prototype)}}class S extends Error{constructor(t){super(t),this.name="MissingWebsocketUriError",Object.setPrototypeOf(this,S.prototype)}}var j=Object.defineProperty,k=Object.getOwnPropertySymbols,E=Object.prototype.hasOwnProperty,M=Object.prototype.propertyIsEnumerable,A=(n,t,e)=>t in n?j(n,t,{enumerable:!0,configurable:!0,writable:!0,value:e}):n[t]=e,w=(n,t)=>{for(var e in t||(t={}))E.call(t,e)&&A(n,e,t[e]);if(k)for(var e of k(t))M.call(t,e)&&A(n,e,t[e]);return n};const d=()=>{};class W{constructor(t){this.timeout=6e4,this._socketConnected=!1,this.handleConnected=e=>(this._socketConnected||(this._socketConnected=!0),e),this.handleDisconnected=(e,i)=>(this._socketConnected&&(this._socketConnected=!1,setTimeout(()=>{i&&i(),this.socketTimeOut()},this.timeout)),e),this._config=t}get id(){var t,e;return(e=(t=this._config)==null?void 0:t.id)!=null?e:""}start(){return this.validate(),this.connect()}validate(){if(!this._config)throw new b("config is required");if(!this._config.token)throw new m("config.token is required");if(!this._config.wsBaseUri)throw new S("config.wsBaseUri is required")}connect(){let t=this.cable;return t&&t!==this.cable?(this.cable=t,this.cable):(t=new D(`${this._config.wsBaseUri}?token=${this._config.token}`),this.cable=t,t.ensureActiveConnection(),this.cable)}getHandlers(t){var e,i,o;const r={received:(e=t==null?void 0:t.received)!=null?e:d,connected:(i=t==null?void 0:t.connected)!=null?i:d,disconnected:(o=t==null?void 0:t.disconnected)!=null?o:d},v=this.handleDisconnected(r.disconnected),x=this.handleConnected(r.connected);return{received:r.received,connected:x,disconnected:v}}subscribe(t,e,i){const o=this.cable;if(!o)return;e?e=w({token:this._config.token},e):e={token:this._config.token};const r=w({channel:t},e),v=this.getHandlers(i);return o.subscriptions.create(r,v)}disconnect(t=!0){return this.cleanup(this.cable,t)}cleanup(t,e){t&&t.disconnect(),e&&(this.cable=void 0)}socketTimeOut(){this._socketConnected||this.cleanup(this.cable,!1)}}h.DEFAULT_HANDLER=d,h.SDKWebSockets=W,Object.defineProperty(h,"__esModule",{value:!0})});
